from ._base import Message, IncompleteMessageException

from .systemcontrol import *
from .motorcontrol import *
from .filterflippercontrol import *
from .solenoidcontrol import *
from .piezocontrol import *
from .nanotrackcontrol import *
from .lasercontrol import *
from .quadcontrol import *
from .teccontrol import *

#Uncomment these lines to ensure all messages are defined
XREF_TDC001 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_DISCONNECT, MGMSG_HW_RESPONSE, MGMSG_HW_RICHRESPONSE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_HUB_REQ_BAYUSED, MGMSG_HUB_GET_BAYUSED, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_ENCCOUNTER, MGMSG_MOT_REQ_ENCCOUNTER, MGMSG_MOT_GET_ENCCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short,MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short,MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_DCPIDPARAMS, MGMSG_MOT_REQ_DCPIDPARAMS, MGMSG_MOT_GET_DCPIDPARAMS, MGMSG_MOT_SET_AVMODES, MGMSG_MOT_REQ_AVMODES, MGMSG_MOT_GET_AVMODES, MGMSG_MOT_SET_POTPARAMS, MGMSG_MOT_REQ_POTPARAMS, MGMSG_MOT_GET_POTPARAMS, MGMSG_MOT_SET_BUTTONPARAMS, MGMSG_MOT_REQ_BUTTONPARAMS, MGMSG_MOT_GET_BUTTONPARAMS, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_REQ_DCSTATUSUPDATE, MGMSG_MOT_GET_DCSTATUSUPDATE, MGMSG_MOT_ACK_DCSTATUSUPDATE, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS, MGMSG_MOT_SUSPEND_ENDOFMOVEMSGS, MGMSG_MOT_RESUME_ENDOFMOVEMSGS]
XREF_TSC001 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_DISCONNECT, MGMSG_HW_RESPONSE, MGMSG_HW_RICHRESPONSE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_HUB_REQ_BAYUSED, MGMSG_HUB_GET_BAYUSED, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_SET_AVMODES, MGMSG_MOT_REQ_AVMODES, MGMSG_MOT_GET_AVMODES, MGMSG_MOT_SET_BUTTONPARAMS, MGMSG_MOT_REQ_BUTTONPARAMS, MGMSG_MOT_GET_BUTTONPARAMS, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_GET_STATUSUPDATE, MGMSG_MOT_SET_SOL_OPERATINGMODE, MGMSG_MOT_REQ_SOL_OPERATINGMODE, MGMSG_MOT_GET_SOL_OPERATINGMODE, MGMSG_MOT_SET_SOL_CYCLEPARAMS, MGMSG_MOT_REQ_SOL_CYCLEPARAMS, MGMSG_MOT_GET_SOL_CYCLEPARAMS, MGMSG_MOT_SET_SOL_INTERLOCKMODE, MGMSG_MOT_REQ_SOL_INTERLOCKMODE, MGMSG_MOT_GET_SOL_INTERLOCKMODE, MGMSG_MOT_SET_SOL_STATE, MGMSG_MOT_REQ_SOL_STATE, MGMSG_MOT_GET_SOL_STATE]
XREF_TST001 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_ENCCOUNTER, MGMSG_MOT_REQ_ENCCOUNTER, MGMSG_MOT_GET_ENCCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_POWERPARAMS, MGMSG_MOT_REQ_POWERPARAMS, MGMSG_MOT_GET_POWERPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_AVMODES, MGMSG_MOT_REQ_AVMODES, MGMSG_MOT_GET_AVMODES, MGMSG_MOT_SET_POTPARAMS, MGMSG_MOT_REQ_POTPARAMS, MGMSG_MOT_GET_POTPARAMS, MGMSG_MOT_SET_BUTTONPARAMS, MGMSG_MOT_REQ_BUTTONPARAMS, MGMSG_MOT_GET_BUTTONPARAMS, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS]
XREF_TST101 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_ENCCOUNTER, MGMSG_MOT_REQ_ENCCOUNTER, MGMSG_MOT_GET_ENCCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_POWERPARAMS, MGMSG_MOT_REQ_POWERPARAMS, MGMSG_MOT_GET_POWERPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_AVMODES, MGMSG_MOT_REQ_AVMODES, MGMSG_MOT_GET_AVMODES, MGMSG_MOT_SET_POTPARAMS, MGMSG_MOT_REQ_POTPARAMS, MGMSG_MOT_GET_POTPARAMS, MGMSG_MOT_SET_BUTTONPARAMS, MGMSG_MOT_REQ_BUTTONPARAMS, MGMSG_MOT_GET_BUTTONPARAMS, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS, MGMSG_MOT_SET_TSTACTUATORTYPE]
XREF_BSC10x_BSC20x = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_DISCONNECT, MGMSG_HW_RESPONSE, MGMSG_HW_RICHRESPONSE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_RACK_REQ_BAYUSED, MGMSG_RACK_GET_BAYUSED, MGMSG_MOD_SET_DIGOUTPUTS, MGMSG_MOD_REQ_DIGOUTPUTS, MGMSG_MOD_GET_DIGOUTPUTS, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_ENCCOUNTER, MGMSG_MOT_REQ_ENCCOUNTER, MGMSG_MOT_GET_ENCCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_REQ_ADCINPUTS, MGMSG_MOT_GET_ADCINPUTS, MGMSG_MOT_SET_POWERPARAMS, MGMSG_MOT_REQ_POWERPARAMS, MGMSG_MOT_GET_POWERPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_GET_STATUSUPDATE, MGMSG_MOT_REQ_STATUSUPDATE, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS, MGMSG_MOT_SET_TRIGGER, MGMSG_MOT_REQ_TRIGGER, MGMSG_MOT_GET_TRIGGER]
XREF_LTS150_LTS300 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_BOWINDEX, MGMSG_MOT_REQ_BOWINDEX, MGMSG_MOT_GET_BOWINDEX, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_GET_STATUSUPDATE, MGMSG_MOT_REQ_STATUSUPDATE, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS]
XREF_MLJ050 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_BOWINDEX, MGMSG_MOT_REQ_BOWINDEX, MGMSG_MOT_GET_BOWINDEX, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_GET_STATUSUPDATE, MGMSG_MOT_REQ_STATUSUPDATE, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS]
XREF_MFF101_MFF102 = [MGMSG_MOD_IDENTIFY, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_GET_STATUSBITS, MGMSG_MOT_SET_MFF_OPERPARAMS, MGMSG_MOT_REQ_MFF_OPERPARAMS, MGMSG_MOT_GET_MFF_OPERPARAMS]
XREF_BBD10x_BBD20x_TBD001 = [MGMSG_MOD_IDENTIFY, MGMSG_MOD_SET_CHANENABLESTATE, MGMSG_MOD_REQ_CHANENABLESTATE, MGMSG_MOD_GET_CHANENABLESTATE, MGMSG_HW_DISCONNECT, MGMSG_HW_RESPONSE, MGMSG_HW_RICHRESPONSE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_RACK_REQ_BAYUSED, MGMSG_RACK_GET_BAYUSED, MGMSG_MOD_SET_DIGOUTPUTS, MGMSG_MOD_REQ_DIGOUTPUTS, MGMSG_MOD_GET_DIGOUTPUTS, MGMSG_MOT_SET_POSCOUNTER, MGMSG_MOT_REQ_POSCOUNTER, MGMSG_MOT_GET_POSCOUNTER, MGMSG_MOT_SET_ENCCOUNTER, MGMSG_MOT_REQ_ENCCOUNTER, MGMSG_MOT_GET_ENCCOUNTER, MGMSG_MOT_SET_VELPARAMS, MGMSG_MOT_REQ_VELPARAMS, MGMSG_MOT_GET_VELPARAMS, MGMSG_MOT_SET_JOGPARAMS, MGMSG_MOT_REQ_JOGPARAMS, MGMSG_MOT_GET_JOGPARAMS, MGMSG_MOT_SET_GENMOVEPARAMS, MGMSG_MOT_REQ_GENMOVEPARAMS, MGMSG_MOT_GET_GENMOVEPARAMS, MGMSG_MOT_SET_MOVERELPARAMS, MGMSG_MOT_REQ_MOVERELPARAMS, MGMSG_MOT_GET_MOVERELPARAMS, MGMSG_MOT_SET_MOVEABSPARAMS, MGMSG_MOT_REQ_MOVEABSPARAMS, MGMSG_MOT_GET_MOVEABSPARAMS, MGMSG_MOT_SET_HOMEPARAMS, MGMSG_MOT_REQ_HOMEPARAMS, MGMSG_MOT_GET_HOMEPARAMS, MGMSG_MOT_SET_LIMSWITCHPARAMS, MGMSG_MOT_REQ_LIMSWITCHPARAMS, MGMSG_MOT_GET_LIMSWITCHPARAMS, MGMSG_MOT_MOVE_HOME, MGMSG_MOT_MOVE_HOMED, MGMSG_MOT_MOVE_RELATIVE_short, MGMSG_MOT_MOVE_RELATIVE_long, MGMSG_MOT_MOVE_COMPLETED, MGMSG_MOT_MOVE_ABSOLUTE_short, MGMSG_MOT_MOVE_ABSOLUTE_long, MGMSG_MOT_MOVE_JOG, MGMSG_MOT_MOVE_VELOCITY, MGMSG_MOT_MOVE_STOP, MGMSG_MOT_MOVE_STOPPED, MGMSG_MOT_SET_EEPROMPARAMS, MGMSG_MOT_SET_PMDPOSITIONLOOPPARAMS, MGMSG_MOT_REQ_PMDPOSITIONLOOPPARAMS, MGMSG_MOT_GET_PMDPOSITIONLOOPPARAMS, MGMSG_MOT_SET_PMDMOTOROUTPUTPARAMS, MGMSG_MOT_REQ_PMDMOTOROUTPUTPARAMS, MGMSG_MOT_GET_PMDMOTOROUTPUTPARAMS, MGMSG_MOT_SET_PMDTRACKSETTLEPARAMS, MGMSG_MOT_REQ_PMDTRACKSETTLEPARAMS, MGMSG_MOT_GET_PMDTRACKSETTLEPARAMS, MGMSG_MOT_SET_PMDPROFILEMODEPARAMS, MGMSG_MOT_REQ_PMDPROFILEMODEPARAMS, MGMSG_MOT_GET_PMDPROFILEMODEPARAMS, MGMSG_MOT_SET_PMDJOYSTICKPARAMS, MGMSG_MOT_REQ_PMDJOYSTICKPARAMS, MGMSG_MOT_GET_PMDJOYSTICKPARAMS, MGMSG_MOT_SET_PMDCURRENTLOOPPARAMS, MGMSG_MOT_REQ_PMDCURRENTLOOPPARAMS, MGMSG_MOT_GET_PMDCURRENTLOOPPARAMS, MGMSG_MOT_SET_PMDSETTLEDCURRENTLOOPPARAMS, MGMSG_MOT_REQ_PMDSETTLEDCURRENTLOOPPARAMS, MGMSG_MOT_GET_PMDSETTLEDCURRENTLOOPPARAMS, MGMSG_MOT_SET_PMDSTAGEAXISPARAMS, MGMSG_MOT_REQ_PMDSTAGEAXISPARAMS, MGMSG_MOT_GET_PMDSTAGEAXISPARAMS, MGMSG_MOT_GET_DCSTATUSUPDATE, MGMSG_MOT_REQ_DCSTATUSUPDATE, MGMSG_MOT_ACK_DCSTATUSUPDATE, MGMSG_MOT_REQ_STATUSBITS, MGMSG_MOT_SUSPEND_ENDOFMOVEMSGS, MGMSG_MOT_RESUME_ENDOFMOVEMSGS, MGMSG_MOT_SET_TRIGGER, MGMSG_MOT_REQ_TRIGGER, MGMSG_MOT_GET_TRIGGER]

#FIXME: define TZ_* messages, then uncomment
#XREF_BNT001_MNA601_TNA001 = [MGMSG_MOD_IDENTIFY, MGMSG_HW_DISCONNECT, MGMSG_HW_RESPONSE, MGMSG_HW_RICHRESPONSE, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_HUB_REQ_BAYUSED, MGMSG_HUB_GET_BAYUSED, MGMSG_PZ_SET_NTMODE, MGMSG_PZ_REQ_NTMODE, MGMSG_PZ_GET_NTMODE, MGMSG_PZ_SET_NTTRACKTHRESHOLD, MGMSG_PZ_REQ_NTTRACKTHRESHOLD, MGMSG_PZ_GET_NTTRACKTHRESHOLD, MGMSG_PZ_SET_NTCIRCHOMEPOS, MGMSG_PZ_REQ_NTCIRCHOMEPOS, MGMSG_PZ_GET_NTCIRCHOMEPOS, MGMSG_PZ_MOVE_NTCIRCTOHOMEPOS, MGMSG_PZ_REQ_NTCIRCCENTREPOS, MGMSG_PZ_GET_NTCIRCCENTREPOS, MGMSG_PZ_SET_NTCIRCPARAMS, MGMSG_PZ_REQ_NTCIRCPARAMS, MGMSG_PZ_GET_NTCIRCPARAMS, MGMSG_PZ_SET_NTCIRCDIA, MGMSG_PZ_SET_NTCIRCDIALUT, MGMSG_PZ_REQ_NTCIRCDIALUT, MGMSG_PZ_GET_NTCIRCDIALUT, MGMSG_PZ_SET_NTPHASECOMPPARAMS, MGMSG_PZ_REQ_NTPHASECOMPPARAMS, MGMSG_PZ_GET_NTPHASECOMPPARAMS, MGMSG_PZ_SET_NTTIARANGEPARAMS, MGMSG_PZ_REQ_NTTIARANGEPARAMS, MGMSG_PZ_GET_NTTIARANGEPARAMS, MGMSG_PZ_SET_NTGAINPARAMS, MGMSG_PZ_REQ_NTGAINPARAMS, MGMSG_PZ_GET_NTGAINPARAMS, MGMSG_PZ_SET_NTTIALPFILTERPARAMS, MGMSG_PZ_REQ_NTTIALPFILTERPARAMS, MGMSG_PZ_GET_NTTIALPFILTERPARAMS, MGMSG_PZ_REQ_NTTIAREADING, MGMSG_PZ_GET_NTTIAREADING, MGMSG_PZ_SET_NTFEEDBACKSRC, MGMSG_PZ_REQ_NTFEEDBACKSRC, MGMSG_PZ_GET_NTFEEDBACKSRC, MGMSG_PZ_REQ_NTSTATUSBITS, MGMSG_PZ_GET_NTSTATUSBITS, MGMSG_PZ_REQ_NTSTATUSUPDATE, MGMSG_PZ_GET_NTSTATUSUPDATE, MGMSG_PZ_ACK_NTSTATUSUPDATE, MGMSG_NT_SET_EEPROMPARAMS, MGMSG_NT_SET_TNA_DISPSETTINGS, MGMSG_NT_REQ_TNA_DISPSETTINGS, MGMSG_NT_GET_TNA_DISPSETTINGS, MGMSG_NT_SET_TNA_IOSETTINGS, MGMSG_NT_REQ_TNA_IOSETTINGS, MGMSG_NT_GET_TNA_IOSETTINGS]
#FIXME: define LA_* commands, then uncomment
#XREF_TLS001 = [MGMSG_MOD_IDENTIFY, MGMSG_HW_DISCONNECT, MGMSG_HW_START_UPDATEMSGS, MGMSG_HW_STOP_UPDATEMSGS, MGMSG_HW_REQ_INFO, MGMSG_HW_GET_INFO, MGMSG_LA_SET_PARAMS, MGMSG_LA_REQ_PARAMS, MGMSG_LA_GET_PARAMS, MGMSG_LA_ENABLEOUTPUT, MGMSG_LA_DISABLEOUTPUT, MGMSG_LA_SET_EEPROMPARAMS, MGMSG_LA_REQ_STATUSUPDATE, MGMSG_LA_GET_STATUSUPDATE, MGMSG_LA_ACK_STATUSUPDATE]

#TODO!
#XREF_QTD001
#XREF_TPA101
#XREF_TTC001
